var app = {
    debug: false,
    templates: {},
    mainContainer: null,
    mainContainerToolbar:null,
    imageIds: null,
    imageFolders: null,
    selectionNum: 0,
    selectionArr: [],
    collectionView: null,
    uploadFiles: [],
    uploadingInfo: {},
    timerHandle: 0,
    timerCount: 0,
    mode: "image", // 模式 'image','video','music','download','files'
    submode: "images",
    folderIndex: 0,
    paths:[],
    folderStack:[],
    currentFolder: null,
    scrollTopStack: [],
    imgElements: null,
    clipboardDatas: [],
    appPath: "/sdcard/FFT",
    preScrollTop:[],
    initTemplate: function() {
        $('script[type="text/x-handlebars-template"]').each(function() {
            html = $(this).html();
            name = $(this).attr("id");
            app.templates[name] = Handlebars.compile(html);
        });

    },
    generateShortId: function() {
        return ("0000" + (Math.random()*Math.pow(36,4) << 0).toString(36)).slice(-4);
    },
    loadNavbar: function(){
        $.ajax({
            url: '/static/html/inc/navbar.html',
            success: function(res) {
                var template = Handlebars.compile(res);
                var html = template();
                $('.right-container').prepend(html);
            }
        })
    },
    render:function(ele, source, data) {
        template = Handlebars.compile(source);
        $(ele).html(template(data));
    },
    loadImages: function() {
        if (app.imageIds) {
            var html = app.templates['template-images']({imageIds: app.imageIds});
            app.mainContainer.html(html);
        }
        app.mainContainerToolbar.html('');
        app.mainContainer.removeClass('has-breadcrumb');
        app.mainContainer.html('');
        $.getJSON('/images/list', function(res){
            console.log("res code " + res["code"]);
            console.log(res);
            if (res["code"] == 0) {
                app.imageIds = res.imageIds;
                console.log("render images");
                var html = app.templates['template-images'](res);
                
                app.mainContainer.html(html);
                app.imgElements = $("img", $(".images-wall"));
                app.lazyloadImages();
            }
        });
        
    },
    onscroll : function() {
        if (app.mode == 'image') {
            app.lazyloadImages();
        }
    },
    pageY: function(El) {
          var top = 0;
          do {
            top += El.offsetTop;
          } while(El.offsetParent && (El = El.offsetParent).nodeName.toUpperCase() != 'BODY');
          return top;
    },
    lazyloadImages: function() {
        var imgEles = app.imgElements;
        var noloadArr = [];
        var i = 0;
        for (i = 0; i < imgEles.length; i++) {
            var isLoaded = $(imgEles[i]).hasClass('loaded');
            if (!isLoaded) {
                noloadArr.push(imgEles[i]);
            }
        }

        var iScrollTop = $("#main-container-content").scrollTop() || document.documentElement.scrollTop || document.body.scrollTop;
        var iClientHeight = $('#main-container-content').height();
        console.log('isScrollTop=' + iScrollTop + " iClientHeight=" + iClientHeight);
        var top = 0;
        for (i = 0; i < noloadArr.length; i++) {
            top = app.pageY(noloadArr[i]);
            // console.log("top " + top);
            if (top > iScrollTop && top < iScrollTop + iClientHeight * 2) {
                noloadArr[i].src = $(noloadArr[i]).attr("data-src");
                console.log("加载图片 " + i);
                if ('' != noloadArr[i].className) {
                    noloadArr[i].className = aNotLoaded[i].className.concat(" loaded");
                } else {
                    noloadArr[i].className = "loaded";
                }
            }
        }

    },
    /// 加载照片文件夹
    loadImageFolders: function() {
        app.paths = [];
        app.paths.push('全部相册');
        if (app.imageFolders) {
            var html = app.templates['template-image-folders']({folders: app.imageFolders});
            app.mainContainer.html(html);
            app.mainContainer.addClass('has-breadcrumb');
            var breadcrumb = app.templates['template-breadcrumb'](app.paths);
            app.mainContainerToolbar.html(breadcrumb);
        }
        $.getJSON('/images/folders', function(res){
            console.log("res code " + res["code"]);
            console.log(res);
            if (res["code"] == 0) {
                app.imageFolders = res.folders;
                console.log("render folders");
                var html = app.templates['template-image-folders'](res);
                app.mainContainer.html(html);
                app.mainContainer.addClass('has-breadcrumb');
                console.log(app.paths);
                var breadcrumb = app.templates['template-breadcrumb'](app.paths);
                app.mainContainerToolbar.html(breadcrumb);
            }
        });
    },
    loadFiles: function(path) {
        console.log("path: " + path);
        var sortBy = localStorage.getItem("sortBy") || '0';
        var sortOrder = localStorage.getItem("sortOrder") || '0';
        var layoutStyle = localStorage.getItem("layoutStyle") || "grid";
        var showHiddenFiles = localStorage.getItem("showHiddenFiles") == 'true'
        console.log('loadFiles showHiddenFiles2 ' + showHiddenFiles);
        $.getJSON('/path', {
            path: path,
            sortBy: sortBy,
            sortOrder: sortOrder,
            showHiddenFiles: showHiddenFiles
        },function(res){
            console.log("res code " + res["code"]);
            console.log(res);
            if (res["code"] == 0) {
                app.currentFolder = res;
                var paths = res.path.split('/');
                if (!paths) {
                    app.paths = "首页";
                } else {
                    app.paths = paths;
                    if (!app.paths[0]) {
                        app.paths[0] = "首页";
                    }
                }
                var html;
                if (layoutStyle == 'list') {
                    html = app.templates['template-folders-list'](res);
                } else {
                    html = app.templates['template-folders'](res);
                }
                var breadcrumb = app.templates['template-breadcrumb'](app.paths);
                app.mainContainer.addClass('has-breadcrumb');
                app.mainContainer.html(html);
                // app.mainContainer.prepend(breadcrumb);
                var breadcrumbToolbar = app.templates['template-breadcrumb-toolbar']()
                app.mainContainerToolbar.html(breadcrumb);
                app.mainContainerToolbar.append(breadcrumbToolbar);
                // app.mainContainer.prepend(breadcrumbToolbar)
                if(layoutStyle == 'grid') {
                    $('#layout-style-grid').addClass('active')
                } else if (layoutStyle == 'list') {
                    $('#layout-style-list').addClass('active')
                }
                if (sortOrder == '0') {
                    $('#sort-order-asc').addClass('active');
                } else if (sortOrder == '1') {
                    $('#sort-order-desc').addClass('active');
                }
                if (sortBy == '0') {
                    $('#sort-by-filename').addClass('active');
                } else if (sortBy == '1') {
                    $('#sort-by-last-modified').addClass('active');
                } else if (sortBy == '2') {
                    $('#sort-by-size').addClass('active');
                }
                $('#show-hidden-files').prop('checked', showHiddenFiles)
                var preScroll = app.preScrollTop[path];
                console.log("path=" + path + " pre scorll=" + preScroll);
                if (preScroll) {
                    document.getElementById('main-container').scrollTop = app.preScrollTop[path];
                } else {
                    document.getElementById('main-container').scrollTop = 0;
                }
                
            }
        });
    },
    loadVideos: function(path) {
        app.mainContainer.removeClass('has-breadcrumb');
        app.mainContainer.html('');
        app.mainContainerToolbar.html('');
        var data = {};
        if (path) {
            data.path = path;
            app.paths = ["首页", app.currentFolder.name];
            console.log('app paths');
            console.log(app.currentFolder);
            console.log(app.paths);
        }
        $.getJSON('/videos',data, function(res) {
            console.log(res);
            if (res["code"] == 0) {
                app.currentFolder = res;
                var html = app.templates['template-video'](res);
                app.mainContainer.html(html);
                if (path) {
                    app.mainContainer.addClass('has-breadcrumb');
                    var breadcrumb = app.templates['template-breadcrumb'](app.paths);
                    app.mainContainerToolbar.html(breadcrumb);
                }
            } else {
                app.mainContainer.html("<h1>没有视频</h1>");
            }
        });
    },
    loadVideoFolders: function() {
        $.getJSON('/video/folders', function(res) {
            console.log(res);
            if (res["code"] == 0) {
                app.currentFolder = res;
                var html = app.templates['template-video-folders'](res);
                app.mainContainer.html(html);
                app.mainContainerToolbar.html('');
            }
        });
    },
    loadMusicList: function(path) {
        var data = {};
        if (path) {

        }
        $.getJSON('/musics',data, function(res) {
            console.log(res);
            if (res["code"] == 0) {
                app.currentFolder = res;
                var html = app.templates['template-music-list-table'](res);
                app.mainContainer.html(html);
                if (path) {
                    app.mainContainer.addClass('has-breadcrumb');
                    var breadcrumb = app.templates['template-breadcrumb'](app.paths);
                    app.mainContainerToolbar.html(breadcrumb);
                }
            } else {
                app.mainContainer.html("<h1>没有音乐</h1>");
            }
        });
    },
    loadClipboard: function() {
        console.log("loadClipboard");
        var html = app.templates['template-clipboard']();
        app.mainContainer.html(html);
        app.mainContainerToolbar.html('');

        for (var i = 0; i < app.clipboardDatas.length; i++) {
            var data = app.clipboardDatas[i];
            if (data.from == 'phone') {
                var itemData = app.templates['template-clipboard-item-from-phone'](data);
                $(".timeline").append(itemData);
            } else {
                var itemData = app.templates['template-clipboard-item-from-pc'](data);
                $(".timeline").append(itemData);
            }
        }
        document.body.scrollTop = document.body.scrollHeight;
    },
    isSelectImageId: function(imageId) {
        for (var i = 0; i < app.selectionArr.length; i++) {
            if (app.selectionArr[i] == imageId) {
                return true;
            }
        }
        return false;
    },
    imageCellClick: function(imageId) {
        console.log("click " + imageId);
        if ($('body').hasClass('selection-mod')) {
            app.checkCell(imageId);
            return;
        }
        var html = app.templates["template-preview"](imageId);
        $('body').append(html);
    },
    closePreview: function() {
        $('.image-preview-container').remove();
    },
    checkCell: function(id) {
        if (app.mode == 'image') {
            var imageId = id;
            console.log('checkCell ' + imageId);
            var cell = $("#cell-id-"+imageId);
            // $("i", cell).toggleClass('checked');
            cell.toggleClass('selection');
            if (cell.hasClass('selection')) {
                app.selectionNum += 1;
                app.selectionArr.push(imageId);
            } else {
                app.selectionNum -= 1;
                for (var i = 0; i < app.selectionArr.length; i++) {
                    if (app.selectionArr[i] == imageId) {
                        app.selectionArr.splice(i, 1);
                        break;
                    }
                }
            }
        } else if (app.mode == 'files' || app.mode =='download' || app.mode == 'fft') {
            console.log('checkCell ' + id);
            var cell = $("#folder-id-" + id);
            cell.toggleClass('selection');
            cell.prop('checked', cell.hasClass('selection'));
            if (cell.hasClass('selection')) {
                app.selectionNum += 1;
                app.selectionArr.push(id);
            } else {
                app.selectionNum -= 1;
                for (var i = 0; i < app.selectionArr.length; i++) {
                    if (app.selectionArr[i] == id) {
                        app.selectionArr.splice(i, 1);
                        break;
                    }
                }
            }
        } else if (app.mode == 'video') {
            var cell = $("#cell-id-" + id);
            cell.toggleClass('selection');
            if (cell.hasClass('selection')) {
                app.selectionNum += 1;
                app.selectionArr.push(id);
            } else {
                app.selectionNum -= 1;
                for (var i = 0; i < app.selectionArr.length; i++) {
                    if (app.selectionArr[i] == id) {
                        app.selectionArr.splice(i, 1);
                        break;
                    }
                }
            }
        } else if (app.mode == 'music') {
            var cell = $("#cell-id-" + id);
            cell.toggleClass('selection');
            if (cell.hasClass('selection')) {
                app.selectionNum += 1;
                app.selectionArr.push(id);
            } else {
                app.selectionNum -= 1;
                for (var i = 0; i < app.selectionArr.length; i++) {
                    if (app.selectionArr[i] == id) {
                        app.selectionArr.splice(i, 1);
                        break;
                    }
                }
            }
        }
        $('#nav-download').text("下载(" + app.selectionNum + ")");
        $('#nav-delete-file').text("删除(" + app.selectionNum + ")");
        if (app.selectionNum >0 ) {
            if (!$('body').hasClass('selection-mod')) {
                $('body').addClass('selection-mod');
            }
        } else {
            $('body').removeClass('selection-mod');
        }
    },
    selectAll: function() {
        app.selectionArr = [];
        if (app.mode == 'image') {
            if (app.submode == 'images') {
                for (var i = 0; i < app.imageIds.length; i++) {
                    app.selectionArr.push(app.imageIds[i]);
                }
            } else {
                var arr = app.imageFolders[app.folderIndex].imageIds;
                for (var i = 0; i < arr.length; i++) {
                    app.selectionArr.push(arr[i]);
                }
            }
        } else if (app.mode == 'video') {
            if ($('.image-folder-cell').length == 0) {
                console.log('videos');
                // app.selectionArr.push(1);
                // app.selectionArr.push(2);
                for (var i = 0; i < app.currentFolder.videoList.length; i++) {
                    app.selectionArr.push(i);
                }
            } else {
                console.log('video folder');
                for (var i = 0; i < app.currentFolder.children.length; i++) {
                    app.selectionArr.push(i);
                }
            }
        } else if (app.mode == 'music') {
            $('.music-list input').prop('checked', true);
            $('.music-list input').addClass('selection');
            for (var i = 0; i < app.currentFolder.children.length; i++) {
                app.selectionArr.push(i);
            }
        } else if (app.mode == 'files' || app.mode == 'download' || app.mode == 'fft') {
            for (var i = 0; i < app.currentFolder.children.length; i++) {
                app.selectionArr.push(i);
            }
        }
        
        app.selectionNum = app.selectionArr.length;
        $('.image-cell').addClass('selection');
        $('body').addClass('selection-mod');
        $('#nav-download').text("下载(" + app.selectionNum + ")");
        if ( $('.file-list input')) {
            $('.file-list input').prop('checked', true);
            $('.file-list input').addClass('selection');
        }
    },
    cancelSelection: function() {
        app.selectionArr = [];
        app.selectionNum = app.selectionArr.length;
        $('.image-cell').removeClass('selection');
        $('body').removeClass('selection-mod');
        $('.file-list input').prop('checked', false);
        $('.file-list input').removeClass('selection');
        if (app.mode == 'music') {
            $('.music-list input').prop('checked', false);
            $('.music-list input').removeClass('selection');
        }
    },
    downloadSelected: function() {
        if (app.mode == 'image') {
            var folderCells = $('.image-folder-cell');
            if (folderCells.length == 0) {
                console.log('downloadSelectedImage');
                console.log(app.selectionArr);
                var data = {
                    "imageIds": app.selectionArr
                };
                var dataStr = JSON.stringify(data);
                $.ajax({
                    url: '/images/download',
                    type: 'POST',
                    dataType: 'json',
                    contentType: 'application/json',
                    data: dataStr,
                    success: function(res) {
                        console.log('download return');
                        console.log(res);
                        if (res.code == 0) {
                            window.location.href = "/images/download?id="+res.id;
                        }
                    }
                });
            } else { // 下载文件夹压缩包
                var downloadFolder = [];
                for (var i = 0; i < app.selectionArr.length; i++) {
                    downloadFolder.push(app.imageFolders[app.selectionArr[i]].folderName);
                }
                var dataStr = JSON.stringify(downloadFolder);
                console.log(dataStr);
                $.ajax({
                    url: '/images/folder/download',
                    type: 'POST',
                    dataType: 'json',
                    contentType: 'application/json',
                    data: dataStr,
                    success: function(res) {
                        console.log('download return');
                        console.log(res);
                        if (res.code == 0) {
                            window.location.href = "/images/folder/download?id="+res.id;
                        }
                    }
                });
            }
        } else if (app.mode == 'files' || app.mode == 'music' || app.mode == 'download' || app.mode == 'fft') {
            var paths = [];
            for (var i = 0; i < app.selectionArr.length; i++) {
                paths.push(app.currentFolder.children[app.selectionArr[i]].absoultePath);
            }
            var data = {
                paths: paths,
                basePath: app.currentFolder.absoultePath
            }
            var dataStr = JSON.stringify(data);
            $.ajax({
                'url': '/file/download',
                'type': 'POST',
                'dataType': 'json',
                'contentType': 'application/json',
                data: dataStr,
                success: function(res) {
                    console.log('download file return');
                    console.log(res);
                    if (res.code == 0) {
                        window.location.href = '/file/download?id=' + res.id;
                    }
                }
            });
        } else if (app.mode == 'video') {
            var paths = [];
            for (var i = 0; i < app.selectionArr.length; i++) {
                var index = app.selectionArr[i];
                if (app.submode == 'videos') {
                    paths.push(app.currentFolder.videoList[index].absoultePath);
                } else {
                    paths.push(app.currentFolder.videoList[index].absoultePath);
                }
            }
            var data = {
                paths: paths,
                type: "video"
            }
            var dataStr = JSON.stringify(data);
            $.ajax({
                'url': '/file/download',
                'type': 'POST',
                'dataType': 'json',
                'contentType': 'application/json',
                data: dataStr,
                success: function(res) {
                    console.log('download file return');
                    console.log(res);
                    if (res.code == 0) {
                        window.location.href = '/file/download?id=' + res.id;
                    }
                }
            });
        }
        
    },
    deleteFile: function() {
        var ret = confirm("确认删除吗？");
        if (!ret) {
            return;
        }
        if (app.mode == 'image') {
            var folderCells = $('.image-folder-cell');
            var data = null;
            if (folderCells.length > 0) {
                var deleteIds = [];
                for (var i = 0; i < app.selectionArr.length; i++) {
                    var folder = app.imageFolders[app.selectionArr[i]];
                    for (var j = 0; j < folder.imageIds.length; j++) {
                        deleteIds.push(folder.imageIds[j]);
                    }
                }
                console.log(deleteIds);
                data = {
                    type: "images",
                    imageIds: deleteIds
                };
            } else {
                console.log('downloadSelectedImage');
                console.log(app.selectionArr);
                data = {
                    type: "images",
                    imageIds: app.selectionArr
                };
            }

            var dataStr = JSON.stringify(data);
            $.ajax({
                url: '/deleteFile',
                type: 'POST',
                dataType: 'json',
                contentType: 'application/json',
                data: dataStr,
                success: function(res) {
                    console.log(res);
                    alert(res.message);
                    setTimeout(function(){
                        app.reload();
                    }, 1000);
                    
                }
            });

        } else if (app.mode == 'files' || app.mode == 'music' || app.mode == 'download' || app.mode == 'fft') {
            var paths = [];
            for (var i = 0; i < app.selectionArr.length; i++) {
                paths.push(app.currentFolder.children[app.selectionArr[i]].absoultePath);
            }
            var data = {
                type: "files",
                paths: paths
            }
            var dataStr = JSON.stringify(data);
            $.ajax({
                'url': '/deleteFile',
                'type': 'POST',
                'dataType': 'json',
                'contentType': 'application/json',
                data: dataStr,
                success: function(res) {
                    console.log(res);
                    alert(res.message);
                    setTimeout(function(){
                        app.reload();
                    }, 1000);
                }
            });
        } else if (app.mode == 'video') {
            var paths = [];
            for (var i = 0; i < app.selectionArr.length; i++) {
                var index = app.selectionArr[i];
                if (app.submode == 'videos') {
                    paths.push(app.currentFolder.videoList[index].absoultePath);
                } else {
                    var folderCells = $('.image-folder-cell');
                    if (folderCells.length > 0) {
                        for (var j = 0; j < app.currentFolder.children[index].children.length; j++) {
                            paths.push(app.currentFolder.children[index].children[j].absoultePath);
                        }
                    } else {
                        paths.push(app.currentFolder.videoList[index].absoultePath);
                    }
                }
            }
            console.log(paths);
            var data = {
                paths: paths,
                type: "files"
            }
            var dataStr = JSON.stringify(data);
            $.ajax({
                'url': '/deleteFile',
                'type': 'POST',
                'dataType': 'json',
                'contentType': 'application/json',
                data: dataStr,
                success: function(res) {
                    console.log(res);
                    alert(res.message);
                    setTimeout(function(){
                        app.reload();
                    }, 1000);
                }
            });
        }
        
    },
    filechanged: function() {
        var files = $('#files')[0].files;
        app.startUploadFiles(files);
    },
    showUploadDialog: function() {
        $('#upload-modal').modal({'backdrop': 'static', 'show': false});
        $('.uploading').show();
        $('.upload-finish').hide();
        $('#upload-cancel').show();
        $('#upload-finish').hide();
        $('#upload-modal').modal('show');
    },
    initUpload: function(folderName) {
        app.uploadingInfo = {
            oneFileUploadedSize: 0, // 目前上传中的文件已上传的大小
            uploadedSize: 0,        // 全部文件已上传的大小
            totalSize: 0,           // 总共大小
            uploadingName: "",      // 名字
            uploadingSize: "",      // 上传文件的大小
            uploadingState: "inited",    // 上传状态, uploading, dealing, done
            fileNum: 0,             // 文件数量
            uploadedNum: 0,         // 已上传的数量
            speed: 0,                // 上传速度
            prevUploadedSize: 0,      // 上一次上传的大小，用来计算速度
            timeUsed: 0,             // 用时
            timeRemain: 0,           // 剩下时间
            folderName: folderName   // 上传的文件夹
        };
        // 定时器检查速度
        app.timerCount = 0;
        app.timerHandle = setInterval(app.checkSpeed, 1000);
    },
    startUploadFiles: function(files) {
        app.showUploadDialog();
        app.initUpload();
        
        app.uploadingInfo.fileNum = files.length;
        for (var i = 0; i < files.length; i++) {
            app.uploadFiles.push({
                file: files[i],
                path: app.currentFolder && app.currentFolder.absoultePath
            });
            app.uploadingInfo.totalSize += files[i].size;
        }
        console.log("files size " + app.uploadingInfo.totalSize);
        $('#files').val("");
        app.updateUploadDialog();
        app.nextFile();
    },
    addToUpload: function(file, path) {
        console.log("addToUpload");
        var p = app.currentFolder && app.currentFolder.absoultePath;
        p = p || app.appPath;
        path = p + path;
        app.uploadFiles.push({
            file: file,
            path: path
        });
        app.uploadingInfo.totalSize += file.size;
        app.uploadingInfo.fileNum = app.uploadFiles.length;
        if (app.uploadingInfo.uploadingState == 'inited') {
            console.log("开始上传 ");
            app.uploadingInfo.uploadingState == 'started';
            app.updateUploadDialog();
            app.nextFile();
        }
    },
    nextFile: function() {
        if (app.uploadFiles.length > 0) {
            var fileInfo = app.uploadFiles[0];
            var file = fileInfo.file;
            app.uploadFiles.splice(0,1);
            if (file) {
                var size = file.size;
                if (size > 1024 * 1024 * 1024) {
                    size = (Math.round(file.size * 100 / (1024 * 1024 * 1024)) / 100).toString() + 'GB';
                } else if (size > 1024 * 1024) {
                    size = (Math.round(file.size * 100 / (1024 * 1024)) / 100).toString() + 'MB';
                } else {
                    size = (Math.round(file.size * 100 / 1024) / 100).toString() + 'KB';
                }
                app.uploadingInfo.uploadingSize = size;
                // app.uploadFile(file);
                app.upload(fileInfo);
            }
        }
    },
    updateUploadDialog: function() {
        console.log(app.uploadingInfo);
        if (app.uploadingInfo.uploadedNum == app.uploadingInfo.total) {
            $('#upload-modal').modal('hide');
        }
        var stateStr = "正在上传: ";
        if (app.uploadingInfo.uploadingState == "done") {
            stateStr = "已完成: ";
        }
        $(".uploading-name").text(stateStr + app.uploadingInfo.uploadingName + " (" + app.uploadingInfo.uploadingSize + ")");
        $(".upload-num").text('已上传: ' + app.uploadingInfo.uploadedNum + " 共: " + app.uploadingInfo.fileNum);
        var percent = Math.round((app.uploadingInfo.uploadedSize + app.uploadingInfo.oneFileUploadedSize) / app.uploadingInfo.totalSize * 100);
        console.log("percent " + percent);
        $(".progress-bar").css('width', percent + "%");
        $(".upload-speed").text("速度: " + app.uploadingInfo.speed + " 用时: " + app.uploadingInfo.timeUsed + " 剩余时间: " + app.uploadingInfo.timeRemain);
    },
    uploadFinish: function(msg) {
        clearInterval(app.timerHandle);
        app.timerHandle = 0;
        $('.uploading').hide();
        console.log($('.location'));
        var message = msg.message;
        if (app.uploadingInfo.folderName) {
            var folder = ((app.currentFolder && app.currentFolder.absoultePath) || app.appPath) + "/" + app.uploadingInfo.folderName 
            message = folder;            
        }
        $('.location').html(message + "</br>" + "用时: " + app.uploadingInfo.timeUsed);
        $('.upload-finish').show();
        $('#upload-cancel').hide();
        $('#upload-finish').show();

        console.log("app.mode=" + app.mode);
        setTimeout(function(){
            app.reload();
        }, 1000);

        if (app.uploadingInfo.folderName) {
            console.log("folder " + folder);
            $.getJSON('/uploadFinish',{
                folder: folder
            }, function(res) {
                console.log(res);
            });
        }

    },
    checkSpeed: function() {
        app.timerCount += 1;

        var speed = (app.uploadingInfo.uploadedSize + app.uploadingInfo.oneFileUploadedSize) - app.uploadingInfo.prevUploadedSize;
        var remainSize = app.uploadingInfo.totalSize - (app.uploadingInfo.uploadedSize + app.uploadingInfo.oneFileUploadedSize);
        // console.log("remainSize " + remainSize + " speed " + speed);
        var remainSecond = Math.round(remainSize / (speed + 1));
        app.uploadingInfo.timeRemain = app.formatSecond(remainSecond);
        app.uploadingInfo.prevUploadedSize = app.uploadingInfo.uploadedSize + app.uploadingInfo.oneFileUploadedSize;
        if (speed > 1024 * 1024) {
            speed = (Math.round(speed *100 / (1024 * 1024)) / 100).toString() + " MB/s";
        } else {
            speed = (Math.round(speed * 100 / 1024) / 100).toString() + " KB/s";
        }
        app.uploadingInfo.speed = speed;
        // 用时
        app.uploadingInfo.timeUsed = app.formatSecond(app.timerCount);
        app.updateUploadDialog();
    },
    formatSecond: function(seconds) {
        var minute = Math.floor(seconds / 60);
        var second = seconds - minute * 60;
        var hour = Math.floor(minute / 60);
        minute = Math.floor(minute - hour * 60);
        return (hour < 10 ? "0" + hour : hour) + ":" + (minute < 10 ? "0" + minute: minute) + ":" + (second < 10? "0" + second: second);
    },
    upload: function(fileInfo) {
        console.log(fileInfo);
        var file = fileInfo.file;
        app.uploadingInfo.uploadingName = file.name;
        app.uploadingInfo.uploadingState = "uploading";
        var reader = new FileReader();
        var CHUNK_SIZE = 50 * 1024 * 1024;   // 50M
        var start = 0;
        var part = 1;
        function seek() {
            var chunkSize = CHUNK_SIZE;
            if (start + chunkSize > file.size) {
                chunkSize = file.size - start;
            }
            var end = start + chunkSize;
            var slice = file.slice(start, end);
            console.log("slice size: " + slice.size);
            reader.readAsArrayBuffer(slice);
            start += chunkSize;
        }
        reader.onloadstart = function() {
            console.log("onloadstart");
        }
        reader.onprogress = function() {
            console.log("onprogress")
        }
        reader.onload = function() {
            console.log("onload " + reader.result.size);
            var xhr = new XMLHttpRequest();
            var url = "/upload?fname=" + encodeURIComponent(file.name) + "&part=" + part;
            if (fileInfo.path) {
                url = url + "&path=" + fileInfo.path;
            }
            if (app.uploadingInfo.folderName) {
                url = url + "&folder=" + app.uploadingInfo.folderName;
            }
            // 最后一个分片
            if (start >= file.size) {
                url = url + "&last=true"
            }
            xhr.open("POST", url);
            xhr.setRequestHeader("Content-Type", "application/octet-stream");
            xhr.onreadystatechange = function() {
                if (xhr.readyState == XMLHttpRequest.DONE) {
                    if (xhr.status == 200) {
                        var json = xhr.responseText;
                        var res = JSON.parse(json);
                        console.log(res);
                        if (res.code == 0) {
                            if (start < file.size) {
                                console.log("上传下一个分片 start: " + start + " size:" + file.size);
                                part += 1;
                                seek();
                            } else {
                                app.uploadingInfo.uploadingState = "done";
                                if (app.uploadFiles.length == 0) {
                                    app.uploadFinish(res);
                                } else {
                                    app.uploadingInfo.uploadedNum += 1;
                                    app.nextFile();
                                    app.updateUploadDialog();
                                }
                            }
                        } else {
                            clearInterval(app.timerHandle);
                            app.timerHandle = 0;
                            $('.uploading').hide();
                            $('.location').html(msg.message);
                            $('.upload-finish').show();
                            $('#upload-cancel').hide();
                            $('#upload-finish').show();
                        }
                    }
                }
            }
            xhr.upload.addEventListener('progress', function(event) {
                if (event.lengthComputable) {
                    // console.log(event);
                    // console.log('uploaded: ' + event.loaded + ' total: ' + app.uploadingInfo.totalSize);
                    app.uploadingInfo.oneFileUploadedSize = event.loaded;
                    if (event.loaded === event.total) {
                        app.uploadingInfo.uploadedSize += app.uploadingInfo.oneFileUploadedSize;
                        app.uploadingInfo.oneFileUploadedSize = 0;
                        if (app.uploadingInfo.uploadedSize > app.uploadingInfo.totalSize) {
                            app.uploadingInfo.uploadedSize = app.uploadingInfo.totalSize
                        }
                    }
                    app.updateUploadDialog();
                }
            }, false);
            xhr.send(reader.result);
            $('#upload-modal').on('hide.bs.modal', function(event) {
                xhr.abort();
                app.uploadFiles = [];
                clearInterval(app.timerHandle);
            });
        }
        seek();
    },
    selectNavItem: function(ele,index) {
        $('#sidebar-page li').removeClass('active');
        $(ele).parent().addClass('active');
        if (index == 0) {
            app.setMode('image');
        } else if (index == 1) {
            app.setMode('video');
        } else if (index == 2) {
            app.setMode('music');
        } else if (index == 3) {
            app.setMode('download');
        } else if (index == 4) {
            app.setMode('files');
        } else if (index == 5) {
            app.setMode('fft');
        } else if (index == 6) {
            app.setMode("clipboard");
        }
    },
    /// 切换模式
    setMode:function(mode) {
        console.log('setMode ' + mode);
        $('#toolbar .btn-group').remove();
        app.mode = mode;
        app.currentFolder = null;
        if (mode == 'image') {
            app.submode = 'images';
            app.loadImages();
            $('#toolbar').prepend(app.templates['template-image-tools']())
        } else if (mode == 'video') {
            app.submode = 'videos';
            app.loadVideos();
            $('#toolbar').prepend(app.templates['template-video-tools']())
        } else if (mode == 'music') {
            app.loadMusicList();
        } else if (mode == 'download') {
            app.loadFiles('/download');
        } else if (mode == 'files') {
            app.loadFiles('/');
        } else if (mode == 'fft') {
            app.loadFiles('/FFT');
        } else if (mode == 'clipboard') {
            app.loadClipboard();
        }

        app.cancelSelection();
    },
    setSubmode: function(submode, ele) {
        app.submode = submode;
        if (app.mode == 'image') {
            if (submode == 'images') {
                app.loadImages();
            } else if (submode == 'folders') {
                app.loadImageFolders();
            }
        } else if (app.mode == 'video') {
            if (submode == 'videos') {
                app.loadVideos();
            } else if (submode == 'folders') {
                app.loadVideoFolders();
            }
        }
        if (ele) {
            $('.btn-group button').removeClass('active');
            $(ele).addClass('active');
        }
        app.cancelSelection();
    },
    clickImageFolder: function(index, ele) {
        console.log('clickImageFolder');
        console.log(app.imageFolders[index]);
        if ($('body').hasClass('selection-mod')) {
            app.checkCell(index);
            return;
        }

        app.folderStack.push(index);
        app.folderIndex = index;
        app.paths.push(app.imageFolders[index].folderName);
        app.currentFolder = app.imageFolders[index];
        var html = app.templates['template-images'](app.imageFolders[index]);
        app.mainContainer.html(html);
        var breadcrumb = app.templates['template-breadcrumb'](app.paths);
        app.mainContainerToolbar.html(breadcrumb);
        app.imgElements = $("img", $(".images-wall"));
        app.lazyloadImages();
    },
    clickBreadcrumb: function(index) {
        console.log('clickBreadcrumb index ' + index);

        if (app.mode == 'image') {
            var pathLen = app.paths.length || 0;
            if (index == 0) {
                app.loadImageFolders();
            }
            else if (index < pathLen) {
                var i = app.folderStack[index-1];
                app.folderStack.splice(index, app.folderStack.length - (index-1));
                app.paths.splice(index+1, pathLen - (index-1));
                app.clickImageFolder(i);
            }
        } else if (app.mode == 'files' || app.mode == 'download' || app.mode == 'fft') {
            var rootPath = app.currentFolder.rootPath;
            if (rootPath[rootPath.length-1] != '/') {
                rootPath += '/';
            }
            var path = "";
            for (var i = 1; i <= index; i++) {
                path += app.paths[i];
                if (i < index) {
                    path += '/';
                }
            }
            app.loadFiles(rootPath + path);
        } else if (app.mode == 'video') {
            app.loadVideoFolders();
            app.mainContainer.removeClass('has-breadcrumb');
        }
    },
    clickFolder: function(index, ele) {
        if ($('body').hasClass('selection-mod')) {
            app.checkCell(index);
            return;
        }
        var child = app.currentFolder.children[index];
        console.log('path current=' + app.currentFolder.absoultePath)
        if (child && child.isFolder) {
            app.preScrollTop[app.currentFolder.absoultePath + "/"] = document.getElementById('main-container').scrollTop; // 滚动高度
            app.loadFiles(child.absoultePath);
        } else {
            var href = "/file?path=" + encodeURIComponent(child.absoultePath);
            var hideA = '<a id="filedownload" target="_blank" href="' + href +'" style="display:none;">文件下载</a>';
            $('body').append(hideA);

            setTimeout(function(){
                console.log('click filedownload');
                document.getElementById('filedownload').click();
                $('#filedownload').remove();
            }, 500);
        }
    },
    videoClick: function(index) {
        if ($('body').hasClass('selection-mod')) {
            app.checkCell(index);
            return;
        }
        var path = app.currentFolder.videoList[index].absoultePath;
        app.openInNewTab("/file?path=" + encodeURIComponent(path));
    },
    openInNewTab:function(href) {
        var hideA = '<a id="filedownload" target="_blank" href="' + href +'" style="display:none;">文件下载</a>';
        $('body').append(hideA);

        setTimeout(function(){
            console.log('click filedownload');
            document.getElementById('filedownload').click();
            $('#filedownload').remove();
        }, 500);
    },
    clickVideoFolder: function(index) {
        var folder = app.currentFolder.children[index];
        app.currentFolder = folder;
        app.loadVideos(folder.absoultePath);
    },
    startHeartBeat: function() {
        app.heartBeartCheck = setInterval(function() {
            $.getJSON("/heartbeat", function(res) {

            }).error(function() {
                $("#message-modal").modal("show");
                clearInterval(app.heartBeartCheck);
            });
        }, 2000);
    },
    // 通过websocket发送消息
    sendWebSocketMessage: function(msg) {
        var data = {
            code: 0,
            message: "",
            text: msg
        };
        console.log("send message " + JSON.stringify(data));
        app.ws.send(JSON.stringify(data));
    },
    // 初始化websocket
    initWebSocket: function() {
        var ws = new WebSocket("ws://" + location.hostname + ":" + location.port);
        app.ws = ws;
        var sendMessage = app.sendWebSocketMessage;

        var keepAlive = function() {
            var timerID = setInterval(function() {
                if (ws.readyState == WebSocket.OPEN) {
                    console.log("发送心跳包");
                    ws.send('');
                } else {
                    clearInterval(timerID);
                }
            }, 1000);
        }

        ws.onopen = function() {
            console.log("ws onopen");
            keepAlive();
        };
        ws.onmessage = function(event) {
            var data = event.data;
            console.log("from server: " + data);
            if (data) {
                var msg = JSON.parse(data);
                app.clipboardDatas.push(msg);
                console.log("onmessage " + msg.text);
                if (app.mode == 'clipboard') {
                    var itemData = app.templates['template-clipboard-item-from-phone'](msg);
                    $(".timeline").append(itemData);
                    document.body.scrollTop = document.body.scrollHeight;
                }
            }
        };
    },
    sendMessage: function() {
        var text = $('#message-textarea').val();
        console.log("message " + text);
        $('#message-textarea').val('');
        if (text != '') {
            app.sendWebSocketMessage(text);
            var msg = {
                code: 0,
                from: 'pc',
                message: '',
                text: text
            };
            app.clipboardDatas.push(msg);
            if (app.mode == 'clipboard') {
                var itemData = app.templates['template-clipboard-item-from-pc'](msg);
                $(".timeline").append(itemData);
                console.log("append item");
                document.body.scrollTop = document.body.scrollHeight;
            }
        }
    },
    // 重新加载当前的模式
    reload: function() {
        if (app.mode == 'image') {
            if (app.submode == 'images') {
                app.loadImages();
            } else {
                app.loadImageFolders();
            }
        } else if (app.mode == 'files' || app.mode == 'fft') {
            console.log('reload files');
            app.loadFiles(app.currentFolder.absoultePath);
        } else if (app.mode == 'video') {
            console.log('reload video');
            if (app.submode == 'folders' &&app.currentFolder && app.currentFolder.absoultePath) {
                app.loadVideos(app.currentFolder.absoultePath);
            } else {
                app.loadVideos();
            }
        } else if (app.mode =='download') {
            app.loadFiles('/download')
        } else if (app.mode == 'music') {
            app.loadMusicList();
        }
        app.cancelSelection();
    },
    // 设置layout样式
    setLayoutStyle: function(style) {
        console.log('setLayoutStyle ' + style)
        if (localStorage.getItem('layoutStyle') == style) {
            return;
        }
        localStorage.setItem('layoutStyle', style);
        app.reload();
    },
    // 设置是否显示隐藏文件
    setShowHiddenFiles: function(checkbox) {
        var checked = 'false';
        if (checkbox.checked) {
            checked = 'true';
        }
        console.log('setShowHiddenFiles ' + checked + " " + localStorage.getItem('showHiddenFiles'));
        if (localStorage.getItem('showHiddenFiles') == checked) {
            return;
        }
        localStorage.setItem('showHiddenFiles', checked);
        app.reload();
    },
    // 设置排序顺序
    setSortOrder: function(sortOrder) {
        console.log('setSortOrder ' + sortOrder);
        if (localStorage.getItem('sortOrder') == sortOrder) {
            return;
        }
        localStorage.setItem('sortOrder', sortOrder);
        app.reload();
    },
    // 设置按什么排序
    setSortBy: function(sortBy) {
        console.log('setSortBy ' + sortBy);
        if (localStorage.getItem('sortBy') == sortBy) {
            return;
        }
        localStorage.setItem('sortBy', sortBy);
        app.reload();
    }
}

function registerHelper() {
    console.log('registerHelper');
    Handlebars.registerHelper('first', function(arr) {
        return arr[0];
    });
    Handlebars.registerHelper('isLastPath', function(index, options) {
        console.log('isLastPath')
        console.log(index);
        if (index == app.paths.length-1) {
            console.log('last');
            return options.fn(this);
        } else {
            return options.inverse(this);
            console.log('not last');
        }
    });
    // 把长的文件名缩短
    Handlebars.registerHelper('minFileName', function(name) {
        if (name.length > 20) {
            var first = name.substring(0, 8);
            var last = name.substring(name.length-8, name.length);
            return first + "..." + last;
        } else {
            return name;
        }
    });
    // 通过文件扩展名显示对应的图标
    Handlebars.registerHelper('iconForExtName', function(name) {
        var arr = name.split('.');
        if (arr.length > 0) {
            var extName = arr[arr.length-1].toLowerCase();
            console.log('extName ' + extName);
            if (extName == 'pdf') {
                return 'far fa-file-pdf';
            } else if (extName == 'doc' || extName == 'docx') {
                return 'far fa-file-word';
            } else if (extName == 'xls' || extName == 'xlsx') {
                return 'far fa-file-excel';
            } else if (extName == 'ppt' || extName == 'pptx') {
                return 'far fa-file-powerpoint';
            } else if (extName == 'zip' || extName == 'rar' || extName == '7z') {
                return 'far fa-file-archive';
            } else if (extName == 'apk') {
                return 'fab fa-android';
            } else if (extName == 'mp3' || extName == 'wav') {
                return 'far fa-file-audio';
            } else if (extName == 'mp4' || extName == 'avi' || extName == 'mkv') {
                return 'far fa-file-video'
            }
            else {
                return 'far fa-file';
            }
        } else {
            return 'far fa-file';
        }
    });
    // 编码
    Handlebars.registerHelper('encode', function(string) {
        return encodeURIComponent(string);
    });
    // 判断是否图片
    Handlebars.registerHelper('isImage', function(name, options) {
        var arr = name.split('.');
        if (arr.length > 0) {
            var extName = arr[arr.length-1].toLowerCase();
            if (extName == 'png' || extName == 'jpeg' || extName == 'jpg') {
                return options.fn(this);
            } else {
                return options.inverse(this);
            }
        } else {
            return options.inverse(this);
        }
    });
    // 把毫秒时间格式化
    Handlebars.registerHelper('formatTime', function(duration) {
        var s = duration / 1000;
        var hour = Math.floor(s / 3600);
        var minute = Math.floor((s % 3600) / 60);
        var second = Math.floor((s % 3600) % 60);
        if (hour < 10) {
            hour = "0" + hour;
        }
        if (minute < 10) {
            minute = "0" + minute;
        }
        if (second < 10) {
            second = "0" + second;
        }
        return hour + ":" + minute + ":" + second;
    });
    // 大小转为字符串
    Handlebars.registerHelper('formatSize', function(size) {
        if (size > 1024) {
            if (size > 1024 * 1024) {
                if (size > 1024 * 1024 * 1024) {
                    return (size / 1024 / 1024 / 1024).toFixed(2) + 'GB';
                } else {
                    return (size / 1024 / 1024).toFixed(2) + 'MB';
                }

            } else {
                return (size / 1024).toFixed(2) + 'KB';
            }

        } else {
            return size + 'B';
        }
    });
}

$(document).ready(function(){
    new Clipboard('.clip');
    // app.loadHeader();
    registerHelper();
    app.mainContainer = $("#main-container-content");
    app.mainContainerToolbar = $('#main-container-toolbar');
    app.initTemplate();
    // app.loadNavbar();
    app.startHeartBeat();
    app.initWebSocket();

    $.getJSON("/defaultTab", function(res) {
        $('#sidebar-page li').removeClass('active');
        var index = res.tab;
        if (index == 0) {
            app.setMode('image');
            $('.tab-photo').addClass('active');
        } else if (index == 1) {
            app.setMode('video');
            $('.tab-video').addClass('active');
        } else if (index == 2) {
            app.setMode('music');
            $('.tab-music').addClass('active');
        } else if (index == 3) {
            app.setMode('download');
            $('.tab-download').addClass('active');
        } else if (index == 4) {
            app.setMode('files');
            $('.tab-files').addClass('active');
        } else if (index == 5) {
            app.setMode('fft');
            $('.tab-fft').addClass('active');
        } else if (index == 6) {
            app.setMode("clipboard");
            $('.tab-clipboard').addClass('active');
        }
    }).error(function() {

    });

    $.getJSON("/appFolder", function(res){
        app.appPath = res.absoultePath;
        console.log("appPath " + app.appPath);
    });

    
    $(window).resize(function() {
        console.log("resize");
        app.onscroll();
    });

    $(window).scroll(function() {
        console.log('scroll');
        app.onscroll();
    });
    $("#main-container-content").scroll(function() {
        console.log('scroll');
        app.onscroll();
    });

    // 拖拉上传
    if (window.File && window.FileReader && window.FileList && window.Blob) {
        // 阻止浏览器默认的拖拽操作
        $(document).on({
            dragleave:function(e){      //拖离
                e.preventDefault();
                $(e.target).removeClass('over');
            },
            drop:function(e){           //拖后放
                e.preventDefault();
            },
            dragenter:function(e){      //拖进
                e.preventDefault();
            },
            dragover:function(e){       //拖来拖去
                e.preventDefault();
                $(e.target).addClass('over');
            }
        });

        var dropHandler = function(e) {
            // $(e.target).removeClass('over');
            e.preventDefault();//取消默认浏览器拖拽效果
            if (e.dataTransfer.files.length == 0) {
                return false;
            }
            

            // app.startUploadFiles(files);
            var iterateFilesAndDirs = function(filesAndDirs, path) {
                for (var i = 0; i < filesAndDirs.length; i++) {
                    if (typeof filesAndDirs[i].getFilesAndDirectories === 'function') {
                        var path = filesAndDirs[i].path;

                        // this recursion enables deep traversal of directories
                        filesAndDirs[i].getFilesAndDirectories().then(function(subFilesAndDirs) {
                            // iterate through files and directories in sub-directory
                            iterateFilesAndDirs(subFilesAndDirs, path);
                        });
                    } else {
                        app.addToUpload(filesAndDirs[i], path);
                    }
                }
            };

            // begin by traversing the chosen files and directories
            if ('getFilesAndDirectories' in e.dataTransfer) {
                console.log('getFilesAndDirectories');
                e.dataTransfer.getFilesAndDirectories().then(function(filesAndDirs) {
                    var folderCount = 0;
                    var fileCount = 0;
                    for (var i = 0; i < filesAndDirs.length; i++) {
                        if (typeof filesAndDirs[i].getFilesAndDirectories === 'function') {
                            folderCount++;
                        } else {
                            fileCount++;
                        }
                    }
                    if (fileCount > 0 && folderCount > 0) {
                        alert("不能同时上传文件和文件夹");
                    }
                    else if (folderCount > 1) {
                        alert("只能上传一个文件夹");
                    } else {
                        var folderName = null;
                        if (folderCount > 0) {
                            folderName = e.dataTransfer.files[0].name;
                        }
                        app.showUploadDialog();
                        app.initUpload(folderName);
                        iterateFilesAndDirs(filesAndDirs, '/');
                    }
                });
            }
        }

        var mainContainer = document.getElementById("main-container-content");
        mainContainer.addEventListener("drop", dropHandler);
        var filesTarget = document.getElementById("file-btn");
        filesTarget.addEventListener("drop", dropHandler);
    }


});

// window.onscroll = function() {
//     console.log("onscroll");
//     app.onscroll();
// }

if (!app.debug) {
    console.log = function(){};
}
